#include "queue.h"
#include <stdio.h>
#include <stdlib.h>

typedef struct Node
{
    struct Node *next;
    int value;
}Nd;

typedef struct Queue
{
    Nd *head;
} Queue;


Queue *allocateStack() {
    Queue* head = malloc(sizeof(Queue));
    head -> head =NULL;
    return head;
}


int push(Queue *queue, int val){
    if (queue == NULL){
        return -1;
    }
    Nd *newNode = malloc(sizeof(Nd));
    if(newNode == NULL){
        return -1;
    }
    newNode -> next = NULL;
    newNode -> value = val;
    if (queue -> head == NULL){
        queue -> head = newNode;
        return 1;
    }

    Nd *current = queue->head;
    while(current -> next != NULL){
        current = current -> next;
    }
    current -> next = newNode;
    return 1;
}


int pop(Queue *queue){
    if(queue == NULL){
        return -1;
    }
    if(queue -> head == NULL){
        return 1;
    }
    Nd *delete = queue -> head;
    queue ->head = queue -> head -> next;
    int data = delete -> value;
    free(delete);
    return data;
}

int sizeQueue(Queue *queue){
    if(queue == NULL){
        return -1;
    }
    if (queue -> head == NULL){
        return 0;
    }
    int len = 0;
    while(queue -> head != NULL){
        len++;
        queue -> head = queue -> head -> next;
    }
    return len;
}

void freeQueue(Queue *queue){
    if (queue == NULL) return;
    Nd *current = queue->head;
    while (current != NULL) {
        Nd *next = current->next;
        free(current);
        current = next;
    }
    queue->head = NULL;
}
